#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU 16000000L
#include <util/delay.h>



void cauta(int *left, int *right)
{
	int s0 = -2, s1 = -2, s2 = -2 , s3 = -2;
	int s4 = 2, s5 = 2, s6 = 2, s7 = 2;

	if (PINA & (1 << 0))
		s0 = 2;
	else 
		s0 = -2;
	if (PINA & (1 << 1))
		s1 = 2;
	else 
		s1 = -2;
	if (PINA & (1 << 2))
		s2 = 2;
	else 
		s2 = -2;

	if (PINA & (1 << 3))
		s3 = 2;
	else 
		s3 = -2;
	
	if (PINA & (1 << 4))
		s4 = 2;
	else 
		s4 = -2;

	if (PINA & (1 << 5))
		s5 = 2;
	else 
		s5 = -2;
		
	if (PINA & (1 << 6))
		s6 = 2;
	else 
		s6 = -2;
		
	if (PINA & (1 << 7))
		s7 = 2;
	else 
		s7 = -2;

	*right = s0 + s1 + s2 + s3; 
	*left = s4 + s5 + s6 + s7;
	
}
int check_direction(int left, int right)
{
	if(left > right)
		return 1;
	else if(right > left)
		return 2;
	return 0;
}

int main(void)
{
	/* Setam directia de input a pinilor */
	DDRA = 0;
	PORTA = 0xFF;	
	
	/* Setez directia pe output a motoarelor */
	DDRC = 0xFF;
	/* Oprim motoarele */
	PORTC = 0;
	
	/* Activam motoarele pe porturile corespunzatoare */
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);

	
	int stanga = 0, dreapta = 0, check;

	while (1) {
		_delay_ms(10);
		
		
		/* Ultima miscare va fi repetata, daca nu vom mai gasi linie */
		if (PINA == 0 || PINA == 255) {
			continue;
		}
		
		cauta(&stanga, &dreapta);
		check = check_direction(stanga, dreapta);

		switch(check) {
		case 1: 
		{
			/* Inchid motor stanga */
			PORTC &= ~(1 << PC2);
			/* Deschid motor dreapta */
			PORTC |= (1 << PC0);	
			break;
		}
		case 2: 
		{
			/* Inchid motor dreapta */
			PORTC &= ~(1 << PC0);
			/* Deshid motor stanga */
			PORTC |= (1 << PC2);			
			break;
		}
		default:
		{
			/* Ambele motoare pornite */
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC2);
			break;
		}

		}
	
	}
	return 0;
}